function [Clabel,Cidx,Sixidx,Dlabel ] = embed_circ_2( N,M,seed,Sixidx,vadj,eadj,vidx,draw )
%embeds vertices onto a circle.  If seed>0 then vertex order along the circle is shuffled.
if seed>0
    smap=randperm(N);
    invsmap = zeros(N,1);
    for i=1:N
        invsmap(smap(i)) = i;
    end
else
    smap=1:N;
    invsmap=1:N;
end


cv=zeros(N,2);
if mod(N,2) %then odd
    for j=1:N
        cv(j,:)=[sin(2*pi*j/(N)),cos(2*pi*j/(N))];
        N0=N;
    end
else
    for j=1:N
        cv(j,:)=[sin(2*pi*j/(N+1)),cos(2*pi*j/(N+1))];
        N0=N+1;
    end
end
cv=cv(smap,1:2);


for k=1:N
    startpos=smap(k);
    fpos=startpos;
    f1=[];
    while isempty(f1)
        if fpos==N
            fpos=1;
        else
            fpos=fpos+1;
        end
        fs=find(smap==fpos); %vertex in forward step position.
        f1=find(vadj(vidx(k)+1:vidx(k+1))==fs);
    end
    curre=eadj(vidx(k)+f1);
    starte=curre;
    for j=1:N-1
        currpos=mod(fpos+j-1,N)+1;
        if currpos==startpos
            break
        end
        fs=find(smap==currpos);
        if sum(vadj(vidx(k)+1:vidx(k+1))==fs)>0
            %then adjacency found
            f1=find(vadj(vidx(k)+1:vidx(k+1))==fs);
            if Sixidx(eadj(vidx(k)+f1),1)==k
                Sixidx(eadj(vidx(k)+f1),4)=curre;
            else
                Sixidx(eadj(vidx(k)+f1),6)=curre;
            end
            if Sixidx(curre,1)==k
                Sixidx(curre,3)=eadj(vidx(k)+f1);
            else
                Sixidx(curre,5)=eadj(vidx(k)+f1);
            end
            curre=eadj(vidx(k)+f1);
        end
    end
    if Sixidx(curre,1)==k
        Sixidx(curre,3)=starte;
    else
        Sixidx(curre,5)=starte;
    end
    if Sixidx(starte,1)==k
        Sixidx(starte,4)=curre;
    else
        Sixidx(starte,6)=curre;
    end
end

% Sixidx
first = zeros(M,1);
maxcrs = N^2;
%maxcrs = (1/12)*(N^4-6*N^3+11*N^2-6*N);
next = zeros(maxcrs,1);
crscoord = zeros(maxcrs,1);
crslabel = zeros(maxcrs,1);
crsdir = zeros(maxcrs,1);
mcnt = 0;
for i=1:M
    f1=smap(Sixidx(i,1));
    f2=smap(Sixidx(i,2));
    swap2 = 0; %list in increasing xcoord order
    if f2>f1
        swap=0;
        H=[(f1-1):-1:1,N:-1:(f2+1)];
        L=(f1+1):(f2-1);
        if cv(invsmap(f1),1)>cv(invsmap(f2),1)
            swap2 = 1; %list in decreasing xcoord order
        end
    else
        swap=1;
        H=[(f1+1):N,1:(f2-1)];
        L=(f1-1):-1:(f2+1);
        if cv(invsmap(f2),1)<cv(invsmap(f1),1)
            swap2 = 1; %list in decreasing xcoord order
        end
    end
    
%     L = (smap(Sixidx(i,1))+1:smap(Sixidx(i,2))-1);
%     H = [smap(Sixidx(i,2))+1:N,1:smap(Sixidx(i,1))-1];
    
    if smap(Sixidx(i,1))<smap(Sixidx(i,2))
        a1 = smap(Sixidx(i,1));
        a2 = smap(Sixidx(i,2));
    else
        a1 = smap(Sixidx(i,2));
        a2 = smap(Sixidx(i,1));
    end
    for j = L
        prev = 0;
        prev2 = 0;
        e1 = 0;
        for k = H
            z = vadj(vidx(invsmap(j))+1:vidx(invsmap(j)+1))==invsmap(k);
            
            if sum(z)>0
                e1 = eadj(vidx(invsmap(j))+1:vidx(invsmap(j)+1));
                e1 = e1(z);
                v1 = k;
                break;
            end
        end
        if e1

            cos1 = cos(pi/N0*(a2-a1));
            cos2 = cos(pi/N0*(a2+a1));
            
            for k = 1:vidx(invsmap(j)+1)-vidx(invsmap(j))
                
                if smap(Sixidx(e1,1))<smap(Sixidx(e1,2))
                    b1 = smap(Sixidx(e1,1));
                    b2 = smap(Sixidx(e1,2));
                else
                    b1 = smap(Sixidx(e1,2));
                    b2 = smap(Sixidx(e1,1));
                end
                
                xcross = (cos1*cos(pi/N0*(b2+b1)) - cos(pi/N0*(b2-b1))*cos2)/sin(pi/N0*(a1+a2-b1-b2));
                
                mcnt = mcnt + 1;
                if mcnt>maxcrs
                    next = [next;zeros(maxcrs,1)];
                    crscoord = [crscoord;zeros(maxcrs,1)];
                    crslabel = [crslabel;zeros(maxcrs,1)];
                    crsdir = [crsdir;zeros(maxcrs,1)];
                    maxcrs=2*maxcrs;
                end
                crscoord(mcnt) = xcross;
                crslabel(mcnt) = e1;
                if invsmap(v1)< invsmap(j)
                    if swap
                        crsdir(mcnt) = -1;   
                    else
                        crsdir(mcnt) = 1;
                    end
                else
                    if swap
                        crsdir(mcnt) = 1;   
                    else
                        crsdir(mcnt) = -1;
                    end
                end
                
                
                if first(i) == 0
                    first(i) = mcnt;
                end
                if prev == 0
                    prev = first(i);
                end


                
                    for r=1:M
                        extreme = 0;
                        if swap2 == 0 
                            if xcross > crscoord(prev)
                            extreme = 1;
                            end
                        else
                            if xcross < crscoord(prev)
                            extreme = 1;
                            end
                        end
%                          [prev,prev2,extreme]
                            if extreme
%                                 curr = prev;
                                if next(prev)~=0
                                    prev2 = prev;
                                    prev = next(prev);
                                else
                                    next(prev) = mcnt;
                                    
                                   
                                    break;
                                end
                                continue;
                            else
                                if prev~=first(i)
%                                     if next(prev)~=0
                                        next(mcnt) = prev;
%                                     end
                                        next(prev2) = mcnt;
                                        prev = mcnt;
%                                         crslabel(1:mcnt)'
                                else
                                    if first(i)~=mcnt
                                        next(mcnt) = first(i);
                                    end
                                    first(i) = mcnt;
                                    
                                    prev = mcnt;
                                end
                                break;
                            end
                            
                    end
                if swap==0
                    if Sixidx(e1,1) == invsmap(j)
                        e1 = Sixidx(e1,4);
                    else
                        e1 = Sixidx(e1,6);
                    end
                    
                    if Sixidx(e1,1)==invsmap(j)
                        if smap(Sixidx(e1,2))<=f2 && smap(Sixidx(e1,2))>=f1
                            %then we have left L and there are no more
                            %crossings
%                              disp('b1')
                            break;
                        end
                        v1 = smap(Sixidx(e1,2));
                    else
                        if smap(Sixidx(e1,1))<=f2 && smap(Sixidx(e1,1))>=f1
                            %then we have left L and there are no more
                            %crossings
%                             v1
%                              disp('b2')
                            break;
                        end
                        v1 = smap(Sixidx(e1,1));
                    end
                    
                else
                    if Sixidx(e1,1) == invsmap(j)
                        e1 = Sixidx(e1,3);
                    else
                        e1 = Sixidx(e1,5);
                    end
                    
                    if Sixidx(e1,1)==invsmap(j)
                        if smap(Sixidx(e1,2))>=f2 && smap(Sixidx(e1,2))<=f1
                            %then we have left L and there are no more
                            %crossings
%                             disp('b3')
                            break;
                        end
                        v1 = smap(Sixidx(e1,2));
                    else
                        if smap(Sixidx(e1,1))>=f2 && smap(Sixidx(e1,1))<=f1
                            %then we have left L and there are no more
                            %crossings
%                             disp('b4')
                            break;
                        end
                        v1 = smap(Sixidx(e1,1));
                    end
                    
                end
                
            end
        end
    end
end

Clabel = zeros(mcnt,1);
Dlabel = zeros(mcnt,1);
Cidx = zeros(M+1,1);
ccnt = 0;
for i=1:M
    curre = first(i);
    if curre~=0
        ccnt = ccnt + 1;
        Clabel(ccnt) = crslabel(curre);
        Dlabel(ccnt) = crsdir(curre);
        for j=1:M
            curre = next(curre);
            if curre~= 0
                ccnt = ccnt+1;
                Clabel(ccnt) = crslabel(curre);
                Dlabel(ccnt) = crsdir(curre);
            else
                break;
            end
        end
    end
    Cidx(i+1) = ccnt;
end

% Clabel'
% pause
if draw %then plot the graph also
    lsp=[];
    for j=1:M  %% bunch of linear spaces for edge lines
        lsp(j,:)=linspace(min(cv(Sixidx(j,1),1),cv(Sixidx(j,2),1)),max(cv(Sixidx(j,1),1),cv(Sixidx(j,2),1)),200);
    end
    clf
    hold off
    plot(cv(:,1),cv(:,2),'o','MarkerSize',8,'MarkerEdgeColor','black','MarkerFaceColor','black');
    axis([-1.1,1.1,-1.1,1.1])
    hold on
    for q=1:M 
%         if Sixidx(q,1)==4 || Sixidx(q,2)==4 || Sixidx(q,1)==5 || Sixidx(q,2)==5
        elinesy=[];
        for s=1:200
            m=((cv(Sixidx(q,2),2)-cv(Sixidx(q,1),2))/(cv(Sixidx(q,2),1)-cv(Sixidx(q,1),1)));
            d=lsp(q,s)*m+(cv(Sixidx(q,1),2)-m*cv(Sixidx(q,1),1));
            
            
            elinesy=[elinesy,d];
        end
        plot(lsp(q,:),elinesy);
%         end
    end
     plot(cv(:,1),cv(:,2),'o','MarkerSize',8,'MarkerEdgeColor','black','MarkerFaceColor','black');
    for q=1:N
        str=num2str(q);
        text(cv(q,1)+0.05,cv(q,2),str)
    end
end
end














