#include "mex.h"
#include "math.h"

void mexFunction( int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[])
{
   int d;
   double *dvadjm;
   double *Fidxm;
   int Ndm;
   double *incidente;
   double *bad_edges;
   double *fin;
   double *deg;
   double *dualel1;
   double *dualel2;
   double *Sixidx1;
   double *Sixidx3;
   double *Sixidx5;
   int mdf;
   int Md;
   double *dist;
   double *prev;
   double *delv;
   
   
   d = mxGetScalar(prhs[0]);
   dvadjm = mxGetPr(prhs[1]);
   Fidxm = mxGetPr(prhs[2]);
   Ndm = mxGetScalar(prhs[3]);
   incidente = mxGetPr(prhs[4]);
   bad_edges = mxGetPr(prhs[5]);
   fin = mxGetPr(prhs[6]);
   deg = mxGetPr(prhs[7]);
   dualel1 = mxGetPr(prhs[8]);
   dualel2 = mxGetPr(prhs[9]);
   Sixidx1 = mxGetPr(prhs[10]);
   Sixidx3 = mxGetPr(prhs[11]);
   Sixidx5 = mxGetPr(prhs[12]);
   //Sixidx = mxGetPr(prhs[9]);
   mdf = mxGetScalar(prhs[13]);
   Md = mxGetScalar(prhs[14]);

   
   
   /*size_t x;
   size_t col;
   size_t row;
   
   size_t col_dualel = mxGetN(prhs[8]);
   size_t row_dualel = mxGetM(prhs[8]);
   dualel = (double **)mxCalloc(col_dualel, sizeof(double *));
   for(x=0; x<col_dualel; x++)
       dualel[x] = (double *) mxCalloc(row_dualel, sizeof(double));
   for(col=0; col<col_dualel; col++) {
       for(row=0; row<row_dualel; row++) {
           dualel[col][row] = mxGetPr(prhs[8])[row+col*row_dualel];
       }
   }
   
   size_t col_Sixidx = mxGetN(prhs[9]);
   size_t row_Sixidx = mxGetM(prhs[9]);
   Sixidx = (double **)mxCalloc(col_Sixidx, sizeof(double *));
   for(x=0; x<col_Sixidx; x++)
       Sixidx[x] = (double *) mxCalloc(row_Sixidx, sizeof(double));
   for(col=0; col<col_Sixidx; col++) {
       for(row=0; row<row_Sixidx; row++) {
           Sixidx[col][row] = mxGetPr(prhs[9])[row+col*row_Sixidx];
       }
   }*/
   
   
   int dvadjmsize = mxGetM(prhs[1]);
   int Fidxmsize = mxGetM(prhs[2]);
   
   plhs[0] = mxCreateDoubleMatrix(d,Ndm+1,mxREAL);
   dist = mxGetPr(plhs[0]);
   plhs[1] = mxCreateDoubleMatrix(d,Ndm+1,mxREAL);
   prev = mxGetPr(plhs[1]);
   plhs[2] = mxCreateDoubleMatrix(d,mdf,mxREAL);
   delv = mxGetPr(plhs[2]);
   
   get_dist(d,dvadjm,Fidxm,Ndm,incidente,bad_edges,fin,deg,dualel1,dualel2,Sixidx1,Sixidx3,Sixidx5,dvadjmsize,Fidxmsize,mdf,Md,dist,prev,delv);
}

void get_dist(int d,double *dvadjm,double *Fidxm,int Ndm,double *incidente,double *bad_edges,double *fin,double *deg,double *dualel1,double *dualel2,double *Sixidx1,double *Sixidx3, double *Sixidx5,int dvadjmsize,int Fidxmsize,int mdf,int Md,double *dist,double *prev,double *delv)
{
   
   int newlabel = Ndm+1;
   mwSize k;
   for(k=1;k<=d;k++)
   {
      //dvadj=dvadjm; COPY
      double dvadj[dvadjmsize + Md];
      mwSize kkk;
      for(kkk=0; kkk<dvadjmsize; kkk++)
         dvadj[kkk] = dvadjm[kkk];
      for(kkk=dvadjmsize; kkk<dvadjmsize+Md; kkk++)
         dvadj[kkk] = 0;
      
      //Fidx=Fidxm;
      double Fidx[Fidxmsize];
      for(kkk=0; kkk<Fidxmsize; kkk++)
         Fidx[kkk] = Fidxm[kkk];
      
      
      
      
      //Nd=Ndm+1;
      int Nd = Ndm+1;
      
      //curre=incidente(fin(k));
      int curre = (int)incidente[(int)fin[k-1]-1];
      
      //while(bad_edges(curre))
      //    if Sixidx(curre,1)==fin(k)
      //        curre = Sixidx(curre,3);
      //    else
      //        curre = Sixidx(curre,5);
      //    end
      //end
      
      
      
      while(bad_edges[curre-1] != 0)
      {
         if(Sixidx1[curre-1] == fin[k-1])
            curre = (int)Sixidx3[curre-1];
         else
            curre = (int)Sixidx5[curre-1];
      }
      
      
      
      
      
      //if Sixidx(curre,1)==fin(k)
      //    nexte=Sixidx(curre,3);
      //else
      //    nexte=Sixidx(curre,5);
      //end
      int nexte = -1;
      if(Sixidx1[curre-1] == fin[k-1])
         nexte = (int)Sixidx3[curre-1];
      else
         nexte = (int)Sixidx5[curre-1];
      
      
      //while(bad_edges(nexte))
      //    if (nexte,1)==fin(k)
      //        nexte=Sixidx(nexte,3);
      //    else
      //        nexte=Sixidx(nexte,5);
      //    end
      //end
      while(bad_edges[nexte-1] != 0)
      {
         if(Sixidx1[nexte-1] == fin[k-1])
            nexte = (int)Sixidx3[nexte-1];
         else
            nexte = (int)Sixidx5[nexte-1];
      }
      
      
      //newv=[];
      //cnt=0;
      int newv[Md];
      mwSize i;
      for(i=0; i<Md; i++)
         newv[i] = 0;
      int cnt = 0;
      
      //for i=1:deg(fin(k))
   
      int temp_curre = curre;
      int temp_nexte = nexte;
   
   // CREATING delv
      for(i=1; i<=(int)deg[(int)fin[k-1]-1]; i++)
      {
         int fc = -1;
         if(Sixidx1[temp_curre-1] == fin[k-1])
            fc = (int)dualel1[temp_curre-1];
         else
            fc = (int)dualel2[temp_curre-1];
      
         delv[k-1 + (i-1)*d] = fc;
      
         temp_curre=temp_nexte;
         
         if(Sixidx1[temp_curre-1] == fin[k-1])
            temp_nexte = (int)Sixidx3[temp_curre-1];
         else
            temp_nexte = (int)Sixidx5[temp_curre-1];
         
         
         while(bad_edges[temp_nexte-1] == 1.0)
         {
            if(Sixidx1[temp_nexte-1] == fin[k-1])
               temp_nexte = (int)Sixidx3[temp_nexte-1];
            else
               temp_nexte = (int)Sixidx5[temp_nexte-1];
         }
         
      }
   //
   
   
      
      for(i=1; i<=(int)deg[(int)fin[k-1]-1]; i++)
      {
         
         //if Sixidx(curre,1)==fin(k)
         //    fc=dualel(curre,1);
         //else
         //    fc=dualel(curre,2);
         //end
         int fc = -1;
         if(Sixidx1[curre-1] == fin[k-1])
            fc = (int)dualel1[curre-1];
         else
            fc = (int)dualel2[curre-1];
         
         //delv(k,i)=fc;
         //delv[k-1][i-1] = fc;
         
      	///////delv[k-1 + (i-1)*d] = fc;
         
         
         //for j=1:Fidx(fc+1)-Fidx(fc)
         //    if dvadj(Fidx(fc)+j)~=dualel(curre,2)  &&  dvadj(Fidx(fc)+j)~=dualel(nexte,1) && dvadj(Fidx(fc)+j)~=dualel(nexte,2) && dvadj(Fidx(fc)+j)~=dualel(curre,1) %assuming correct order in dualel vector
         //        cnt=cnt+1;
         //        newv(cnt)=dvadj(Fidx(fc)+j);
         //        f1=[];
         //        for r=Fidx(newv(cnt))+1:Fidx(newv(cnt)+1)
         //            if dvadj(r)==fc
         //                f1=[f1,r-Fidx(newv(cnt))];
         //            end
         //        end
         //
         //        dvadj(Fidx(newv(cnt))+f1)=newlabel;
         //        dvadj(Fidx(fc)+j)=fc;
         //
         //
         //    end
         //end
         
         mwSize j;
         for(j=1; j<=Fidx[fc]-Fidx[fc-1]; j++)
         {
            //if(dvadj[(int)Fidx[fc-1]+j-1] != dualel2[curre-1] && dvadj[(int)Fidx[fc-1]+j-1] != dualel1[nexte-1] && dvadj[(int)Fidx[fc-1]+j-1] != dualel2[nexte-1] && dvadj[(int)Fidx[fc-1]+j-1] != dualel1[curre-1])
            int createEdge = 1;
         
            mwSize jj;
            for(jj=1; jj<=mdf; jj++)
            {
               if(delv[k-1 + (jj-1)*d] == (int)dvadj[(int)Fidx[fc-1]+j-1])
               {
                  createEdge = 0;
                  break;
               }
            }		
         
         
            if(createEdge == 1)
            {
               cnt = cnt + 1;
               newv[cnt-1] = (int)dvadj[(int)Fidx[fc-1]+j-1];
               //dist[cnt-1] = cnt;
               int f1[8*(int)(Fidx[newv[cnt-1]] - Fidx[newv[cnt-1]-1])];
               int f1cnt = 0;
               mwSize r;
               for(r=(int)Fidx[newv[cnt-1]-1]+1; r<=(int)Fidx[newv[cnt-1]]; r++)
               {
                  if((int)dvadj[r-1] == fc)
                  {
                     f1[f1cnt] = r - (int)Fidx[newv[cnt-1]-1];
                     f1cnt = f1cnt + 1;
                  }
               }
               
               for(r=1; r<=f1cnt; r++)
               {
                  dvadj[(int)Fidx[newv[cnt-1]-1]+f1[r-1]-1] = newlabel;
               }
               dvadj[(int)Fidx[fc-1]+j-1] = fc;
            }
         }
         
         
         //dist[0] = cnt;
         
         //curre=nexte;
         curre=nexte;
         //delv[0] = curre;
         
         //if(Sixidx[0][curre-1] == fin[k-1])
         //    delv[0] = 100;
         
         //if Sixidx(curre,1)==fin(k)
         //    nexte=Sixidx(curre,3);
         //else
         //    nexte=Sixidx(curre,5);
         //end
         if(Sixidx1[curre-1] == fin[k-1])
            nexte = (int)Sixidx3[curre-1];
         else
            nexte = (int)Sixidx5[curre-1];
         
         //while(bad_edges(nexte))
         //    if Sixidx(nexte,1)==fin(k)
         //        nexte=Sixidx(nexte,3);
         //    else
         //        nexte=Sixidx(nexte,5);
         //    end
         //end
         while(bad_edges[nexte-1] == 1.0)
         {
            if(Sixidx1[nexte-1] == fin[k-1])
               nexte = (int)Sixidx3[nexte-1];
            else
               nexte = (int)Sixidx5[nexte-1];
         }
         
         //end
      }
      
      //Fidx(newlabel+1)=Fidx(newlabel)+cnt;
      Fidx[newlabel] = Fidx[newlabel-1]+(cnt);
      
      //dist[0] = dvadj[dvadjmsize+cnt-1];
      
      //dvadj(end+1:end+cnt)=newv;
      
      for(i=1; i<=cnt; i++)
         dvadj[dvadjmsize+i-1]=newv[i-1];
      
      
      
      
      
      
      //[dist(k,1:Nd),prev(k,1:Nd)]=sp(dvadj,Fidx,Nd,Nd);
      
      
      
      int totaldone = 1;
      bool done[Nd];
      mwSize jj;
      for(jj=0; jj<Nd; jj++)
         done[jj] = false;
      
      done[Nd-1] = true;
      int looknext[Nd+1];
      for(jj=0; jj<Nd+1; jj++)
         looknext[jj] = 0;
      looknext[0] = Nd;
      int looknextcount = 1;
      int index = 0;
      int count = 0;
      int gothere = 0;
      
      while(looknext[index] != 0)
      {
         int v = looknext[index];
         
         for(i=(int)Fidx[v-1];i<(int)Fidx[v];i++)
         {
            int check = (int)(dvadj[i]);
            if(done[check-1] == false)
            {
               looknext[looknextcount] = check;
               looknextcount = looknextcount+1;
               //dist[k-1][check-1] = dist[k-1][v-1] + 1;
               dist[k-1 + (check-1)*d] = dist[k-1 + (v-1)*d] + 1;
               //prev[k-1][check-1] = v;
               prev[k-1 + (check-1)*d] = v;
               done[check-1] = true;
               totaldone = totaldone + 1;
            }
         }
         index = index + 1;
         
      }
      
      
      //dist(k,Nd)=Nd;
      //dist[k-1][Nd-1] = Nd;
      dist[k-1 + (Nd-1)*d] = Nd;
      
      
   //end
   }
   
}