function [Sixidx,Clabel,Dlabel,Cidx] = get_spring_data(el,deg,vadj,vidx,providecoords,x,y,seed)

N = max(max(el));

Clabel = zeros(100,1);
Cidx = zeros(size(el,1)+1,1);
Dlabel = zeros(100,1);

if providecoords==0
    [x,y] = kksl(el,vadj,vidx,1,10,seed);
    x = x + 0.001*rand(size(x,1),1);
    y = y + 0.001*rand(size(y,1),1);
end

%     clf;
%     hold on;
%     
%     axis([min(x) max(x) min(y) max(y)]);
%     for i=1:N
%         text(x(i),y(i),num2str(i));
%     end
%     for i=1:size(el,1)
%         plot([x(el(i,1)) x(el(i,2))],[y(el(i,1)) y(el(i,2))],'k');
%     end
Sixidx = [el zeros(size(el,1),4)];

% hold on;
Clabel_count = 0;
for i=1:size(el,1)
    t_values = zeros(size(el,1),1);
    count = 0;
    for j=1:size(el,1)
        v1 = el(i,1);
        v2 = el(i,2);
        v3 = el(j,1);
        v4 = el(j,2);
        if(v1 == v3 || v1 == v4 || v2 == v3 || v2 == v4)
            continue;
        end
        
        a0 = x(v1);
        a1 = x(v2);
        a2 = x(v3);
        a3 = x(v4);
        b0 = y(v1);
        b1 = y(v2);
        b2 = y(v3);
        b3 = y(v4);
        
        if abs(a1-a0)<1e-6 && abs(a2-a3)<1e-8
            %parallel vertical
            continue
        end
        
        if abs((b1-b0)/(a1-a0) - (b3-b2)/(a3-a2))<1e-8
            %then parallel
            continue;
        end
        
        t = ((a3-a2)*(b0-b2) + (b2-b3)*(a0-a2))/((b3-b2)*(a1-a0) + (a2-a3)*(b1-b0));
        if abs(b3-b2) < 1e-6
            s = (a0 - a2 + (a1-a0)*t)/(a3-a2);
        else
            s = (b0 - b2 + (b1-b0)*t)/(b3-b2);
        end
            
            
        
        if(t > 0 && t < 1 && s > 0 && s < 1)
%             disp(['Crossing between edge (' num2str(v1) ',' num2str(v2) ') and (' num2str(v3) ',' num2str(v4) ')']);
%             plot(a0 + (a1-a0)*t,b0+(b1-b0)*t,'rx');
            
            count = count + 1;
            
            t_values(count) = t;
            Clabel_count = Clabel_count + 1;
            if(mod(Clabel_count,100) == 0)
                Clabel = [Clabel;zeros(100,1)];
                Dlabel = [Dlabel;zeros(100,1)];
            end
            Clabel(Clabel_count) = j;  
            xc = a0 + (a1-a0)*t;
            yc = b0 + (b1-b0)*t;
            ang_v1 = atan((b0-yc)/(a0-xc));
            if(a0 < xc)
                ang_v1 = ang_v1 + pi;
            end
            ang_v2 = atan((b1-yc)/(a1-xc));
            if(a1 < xc)
                ang_v2 = ang_v2 + pi;
            end
            ang_v3 = atan((b2-yc)/(a2-xc));
            if(a2 < xc)
                ang_v3 = ang_v3 + pi;
            end
            if(ang_v2 < ang_v1)
                if(ang_v3 > ang_v2 && ang_v3 < ang_v1)
                    Dlabel(Clabel_count) = -1;
                else
                    Dlabel(Clabel_count) = 1;
                end
            else
                if(ang_v3 > ang_v2 || ang_v3 < ang_v1)
                    Dlabel(Clabel_count) = -1;
                else
                    Dlabel(Clabel_count) = 1;
                end
            end
            
        end
    end
    [~,b] = sort(t_values(1:count));
    
    Clabel(Clabel_count-count+1:Clabel_count) = Clabel(Clabel_count-count+b);
    Dlabel(Clabel_count-count+1:Clabel_count) = Dlabel(Clabel_count-count+b);
    Cidx(i+1) = Clabel_count;
end
% hold off;
Clabel = Clabel(1:Clabel_count);
Dlabel = Dlabel(1:Clabel_count);

angles = zeros(size(el,1),2);
for i=1:size(el,1)
    v1 = el(i,1);
    v2 = el(i,2);
    x1 = x(v1);
    x2 = x(v2);
    y1 = y(v1);
    y2 = y(v2);
    if(abs(x2-x1)<1e-6)
        if y1>y2
            angles(i,[1 2]) = [3*pi/2 pi/2];
        else
            angles(i,[1 2]) = [pi/2 3*pi/2];
        end
    else
        ang = atan((y2-y1)/(x2-x1));
        if(x1 < x2)
            angles(i,[1 2]) = [ang ang+pi];
        else
            angles(i,[1 2]) = [ang+pi ang];
        end
    end
end

for i=1:N
    count = 0;
    for j=1:size(el,1)
        if(el(j,1) == i)
            count = count + 1;
            vert_ang(i,count) = angles(j,1);
            vert_ind(i,count) = j;
        end
        if(el(j,2) == i)
            count = count + 1;
            vert_ang(i,count) = angles(j,2);
            vert_ind(i,count) = j;
        end
    end
    [~,b] = sort(vert_ang(i,1:deg(i)),'descend');
    vert_ind(i,1:deg(i)) = vert_ind(i,b);   
end

for i=1:N
    next = [2:deg(i) 1];
    prev = [deg(i) 1:deg(i)-1];
    for j=1:deg(i)
        edge = vert_ind(i,j);
        if(el(edge,1) == i)
            Sixidx(edge,3) = vert_ind(i,next(j));
            Sixidx(edge,4) = vert_ind(i,prev(j));
        else
            Sixidx(edge,5) = vert_ind(i,next(j));
            Sixidx(edge,6) = vert_ind(i,prev(j));
        end
    end
end

end