#include "mex.h"

void mexFunction( int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[])
{
   int Nd;
   double *rel_chk;
   double *Fidx;
   double *dvadj;
   double *deadj;
   double *newfidx;
   double *final_newd;
   double *final_newe;
   int maxFsize;

   int M;
   double *poolidx;
   double *dualel1;
   double *dualel2;
   double *bad_edge;
   int sumpooldeg;
   double *newel;
   double *newmaxFindex;
    
    
    
   Nd = mxGetScalar(prhs[0]);
   rel_chk = mxGetPr(prhs[1]);
   Fidx = mxGetPr(prhs[2]);
   dvadj = mxGetPr(prhs[3]);
   deadj = mxGetPr(prhs[4]);
   
    
   M = mxGetScalar(prhs[5]);
   poolidx = mxGetPr(prhs[6]);
   dualel1 = mxGetPr(prhs[7]);
   dualel2 = mxGetPr(prhs[8]);
   bad_edge = mxGetPr(prhs[9]);
   sumpooldeg = mxGetScalar(prhs[10]);
   maxFsize = mxGetScalar(prhs[11]);
    
   double newd[(int)Fidx[Nd]];
   mwSize i;
   for(i=1; i<=(int)Fidx[Nd]; i++)
      newd[i-1] = 0;
   double newe[(int)Fidx[Nd]];
   for(i=1; i<=(int)Fidx[Nd]; i++)
      newe[i-1] = 0;
   double poole[sumpooldeg];
   for(i=1; i<=sumpooldeg; i++)
      poole[i-1] = 0;
   double poolf[sumpooldeg];
   for(i=1; i<=sumpooldeg; i++)
      poolf[i-1] = 0;
    

   plhs[2] = mxCreateDoubleMatrix(Nd+1,1,mxREAL);
   newfidx = mxGetPr(plhs[2]);
   for(i=1; i<Nd+1; i++)
      newfidx[i-1] = 0;

   plhs[3] = mxCreateDoubleMatrix(M,2,mxREAL);
   newel = mxGetPr(plhs[3]);
   for(i=1; i<=M; i++)
   {
      newel[i-1] = dualel1[i-1];
      newel[i-1 + M] = dualel2[i-1];
   }    
    
   plhs[4] = mxCreateDoubleMatrix(1,1,mxREAL);
   newmaxFindex = mxGetPr(plhs[4]);
    
    
   int poolcnt = mxGetM(prhs[6])-1;
    
   int newdsize = merge(Nd,rel_chk,Fidx,dvadj,deadj,poole,poolf,M,poolidx,dualel1,dualel2,bad_edge,sumpooldeg,maxFsize,poolcnt,newd,newe,newfidx,newel,newmaxFindex);
   plhs[0] = mxCreateDoubleMatrix(newdsize,1,mxREAL);
   final_newd = mxGetPr(plhs[0]);
   plhs[1] = mxCreateDoubleMatrix(newdsize,1,mxREAL);
   final_newe = mxGetPr(plhs[1]);

    
   for(i=1; i<=newdsize; i++) {
      final_newd[i-1] = newd[i-1];
      final_newe[i-1] = newe[i-1];
   }
}



int merge(int Nd, double *rel_chk, double *Fidx, double *dvadj, double *deadj, double *poole, double *poolf, int M, double *poolidx, double *dualel1, double *dualel2, double *bad_edge, int sumpooldeg, int maxFsize, int poolcnt, double *newd, double *newe, double *newfidx, double *newel, double *newmaxFindex)
{
   mwSize i;
    
   newmaxFindex[0] = -1;
        
   int poolcurr[poolcnt];
   for(i=1; i<=poolcnt; i++)
      poolcurr[i-1] = 0;
        
   for(i=1; i<=M; i++)
   {
      if(rel_chk[(int)dualel1[i-1]-1] > 0)
      {
         if(bad_edge[i-1] == 0)
         {
            int q1 = rel_chk[(int)dualel1[i-1]-1];
            newel[i-1] = Nd+q1;
            poolcurr[q1-1]++;  //correct notation?
            poole[(int)poolidx[q1-1] + (int)poolcurr[q1-1] - 1] = i;
            if (rel_chk[(int)dualel2[i-1]-1] == 0) //is this going to work for non integers??
            {
               poolf[(int)poolidx[q1-1] + (int)poolcurr[q1-1] - 1] = dualel2[i-1];
            }
            else
            {
               poolf[(int)poolidx[q1-1] + (int)poolcurr[q1-1] - 1] = Nd + rel_chk[(int)dualel2[i-1]-1];
            }
         }
      }
      if(rel_chk[(int)dualel2[i-1]-1] > 0)
      {
         if(bad_edge[i-1] == 0)
         {
            int q1 = rel_chk[(int)dualel2[i-1]-1];
            newel[i-1 + M] = Nd+q1;
            poolcurr[q1-1]++;  //correct notation?
            poole[(int)poolidx[q1-1] + (int)poolcurr[q1-1] - 1] = i;
            if (rel_chk[(int)dualel1[i-1]-1] == 0)  
            {
               poolf[(int)poolidx[q1-1] + (int)poolcurr[q1-1] - 1] = dualel1[i-1];
            }
            else
            {
               poolf[(int)poolidx[q1-1] + (int)poolcurr[q1-1] - 1] = Nd + rel_chk[(int)dualel1[i-1]-1];
            }
         }
      }
   }
//newfidx=zeros(Nd+1,1);
    
//cnt=0;
//cntstart=0;
//istart=0;
   int cnt = 0;
   int cntstart = 0;
   int istart = 0;
    
    //for i=1:Nd
//    if rel_chk(i)==0
//
//          if istart==0
//          cntstart=cnt;
//          istart=i;
//          end
//          cnt=cnt+Fidx(i+1)-Fidx(i);
//    else
//        if istart>0
//              newd(cntstart+1:cnt,1)=dvadj(Fidx(istart)+1:Fidx(i)); %can do a larger fill here
//              newe(cntstart+1:cnt,1)=deadj(Fidx(istart)+1:Fidx(i));
//              istart=0;
//        end
//    end
//    newfidx(i+1)=cnt;
//end
    
    //int zerorelchk = 0;

   for(i=1; i<=Nd; i++)
   {
      if(rel_chk[i-1] == 0)
      {
            //zerorelchk = zerorelchk + 1;
         if(istart == 0)
         {
            cntstart = cnt;
            istart = i;
         }
         cnt = cnt + Fidx[i]-Fidx[i-1];
         if((int)(Fidx[i]-Fidx[i-1]) > maxFsize)
         {
            maxFsize = (int)(Fidx[i]-Fidx[i-1]);
            newmaxFindex[0] = i;
         }
      }
      else
      {
         if(istart>0)
         {
            mwSize j;
            int tempcnt = Fidx[istart-1];
            for(j=cntstart+1; j<=cnt; j++)
            {
               tempcnt = tempcnt + 1;
               newd[j-1]=dvadj[tempcnt - 1];
               newe[j-1]=deadj[tempcnt - 1];
               istart = 0;
            }
         }
      }
      newfidx[i] = cnt;
   }
    
    //if(newmaxFindex[0] == -1)
    //    newmaxFindex[0] = -zerorelchk;
    
    
    
//if  rel_chk(i)==0
//    i=i+1;
//              newd(cntstart+1:cnt,1)=dvadj(Fidx(istart)+1:Fidx(i)); %can do a larger fill here
//              newe(cntstart+1:cnt,1)=deadj(Fidx(istart)+1:Fidx(i));
//end
    
   if(rel_chk[Nd-1] == 0)
   {
      mwSize j;
      int tempcnt = Fidx[istart-1];
      for(j=cntstart+1; j<=cnt; j++)
      {
         tempcnt = tempcnt + 1;
         newd[j-1]=dvadj[tempcnt - 1];
         newe[j-1]=deadj[tempcnt - 1];
      }
   }
    
    
//f1=rel_chk(newd)>0;
//newd(f1)=Nd+rel_chk(newd(f1));
    
   for(i=1; i<=cnt; i++)
   {
      if(rel_chk[(int)newd[i-1]-1] > 0)
      {
         newd[i-1] = Nd+rel_chk[(int)newd[i-1]-1];
      }
   }

   for(i=1; i<=sumpooldeg; i++)
   {
      newe[cnt+i-1] = poole[i-1];
      newd[cnt+i-1] = poolf[i-1];
   }
    
   int newdsize = cnt + sumpooldeg;
   return newdsize;
    
//newe=[newe(1:cnt);poole];  %preallocate these and fill them instead of creating a new one and attaching on the end.
//newd=[newd(1:cnt);poolf];
}