function [ newd,newfidx,newel,pooledgemap,merged_face_labels,newNd,newMd,newe,maxFindex,rel_chk] = merge_dual( Nd,Fidx,dualel,M,bad_edge,dvadj,ddeg,deadj,bad_edge_labels )
%facenumbers stay the same, except merged faces are now empty and replaced
%with a pooled face at the end, and pooledgemap gives one of the original
%faces which were merged.

rel_chk=zeros(Nd,1);
poolcnt=0;
pooledgemap=zeros(2*numel(bad_edge_labels),1);
merged_face_labels=zeros(1,2*numel(bad_edge_labels));
mcnt=0;
degpool=ddeg;
face_checked = zeros(Nd,1);

for i=bad_edge_labels
    degpool(dualel(i,1))=degpool(dualel(i,1))-1;
    degpool(dualel(i,2))=degpool(dualel(i,2))-1;
    q1=rel_chk(dualel(i,1));
    q2=rel_chk(dualel(i,2));
    if q1 && q2  && q1~=q2
        %then join two 'pooled faces' together.
        if q1>q2
            qt=q1;
            q1=q2;
            q2=qt;
        end
        rel_chk(rel_chk==q2)=q1;
        f1=rel_chk>q2;
        rel_chk(f1)=rel_chk(f1)-1;
        tt=pooledgemap(q2+1:poolcnt);
        poolcnt=poolcnt-1;
        pooledgemap(q2:poolcnt+1)=[tt;0];
    else
        if ~q1
            %then this face is yet to be merged
            if ~q2 %then both faces yet to be merged, so merge them and start a new 'pooled face'
                poolcnt=poolcnt+1;
                rel_chk(dualel(i,1))=poolcnt;
                rel_chk(dualel(i,2))=poolcnt;
                pooledgemap(poolcnt)=dualel(i,1);
                q2=poolcnt; %to stop next if ~q2 from hapenning.
                if(face_checked(dualel(i,2)) == 0)
                    mcnt=mcnt+1;
                    merged_face_labels(mcnt)=dualel(i,2);
                    face_checked(dualel(i,2)) = 1;
                end
            else
                rel_chk(dualel(i,1))=q2;
            end
            q1=poolcnt;
            if(face_checked(dualel(i,1)) == 0)
                mcnt=mcnt+1;
                merged_face_labels(mcnt)=dualel(i,1);
                face_checked(dualel(i,1)) = 1;
            end
        end
        if ~q2
            rel_chk(dualel(i,2))=q1;
            if(face_checked(dualel(i,2)) == 0)
                mcnt=mcnt+1;
                merged_face_labels(mcnt)=dualel(i,2);
                face_checked(dualel(i,2)) = 1;
            end
        end
    end
end

pooldeg=zeros(poolcnt,1);
merged_face_labels=merged_face_labels(1:mcnt);

for i=merged_face_labels
    pooldeg(rel_chk(i))=pooldeg(rel_chk(i))+degpool(i);
end
[maxFsize,maxFindex] = max(pooldeg);

%newd=zeros(Fidx(end),1);
%newel=dualel;
%poolf=zeros(sum(pooldeg),1);
poolidx=zeros(poolcnt+1,1);
for i=2:poolcnt+1
    poolidx(i)=poolidx(i-1)+pooldeg(i-1);
end
%poolcurr=zeros(poolcnt,1);
%newe=zeros(Fidx(end),1);
%poole=zeros(sum(pooldeg),1); %edge lookup

% for i=merged_face_labels
%    for j=Fidx(i)+1:Fidx(i+1)
%        if bad_edge(deadj(j))==0
%           ne=deadj(j);
%           q1=rel_chk(i);
%           if newel(ne,1)==i
%              newel(ne,1)=Nd+q1;
%           else
%              newel(ne,2)=Nd+q1;
%           end
%           poolcurr(q1)=poolcurr(q1)+1;
%           if rel_chk(dvadj(j))
%           poolf(poolidx(q1)+poolcurr(q1))=Nd+rel_chk(dvadj(j));
%           else
%           poolf(poolidx(q1)+poolcurr(q1))=dvadj(j);
%           end
%           poole(poolidx(q1)+poolcurr(q1))=ne;
%        end
%    end
% end

% for i=1:M
%     if rel_chk(dualel(i,1)) && bad_edge(i)==0
%
%         q1=rel_chk(dualel(i,1));
%         newel(i,1)=Nd+q1;
%         poolcurr(q1)=poolcurr(q1)+1;
%         if ~rel_chk(dualel(i,2))
%             poolf(poolidx(q1)+poolcurr(q1))=dualel(i,2);
%             %             poole(poolidx(rel_chk(dualel(i,1)))+poolcurr(rel_chk(dualel(i,1))))=i;
%         else
%             poolf(poolidx(q1)+poolcurr(q1))=Nd+rel_chk(dualel(i,2));
%         end
%         poole(poolidx(q1)+poolcurr(q1))=i;
%     end
%     if rel_chk(dualel(i,2)) && bad_edge(i)==0
%         q2=rel_chk(dualel(i,2));
%         newel(i,2)=Nd+q2;
%         poolcurr(q2)=poolcurr(q2)+1;
%         if ~rel_chk(dualel(i,1))
%             poolf(poolidx(q2)+poolcurr(q2))=dualel(i,1);
%         else
%             poolf(poolidx(q2)+poolcurr(q2))=Nd+rel_chk(dualel(i,1));
%         end
%         poole(poolidx(q2)+poolcurr(q2))=i;
%
%     end
% end



% poolidx'
% [poolf,bad_edge(poole)]
%     pause

%[newd,newe,newfidx] = md(Nd,rel_chk,Fidx,dvadj,deadj,poole,poolf);
[newd,newe,newfidx,newel,newmaxFindex] = md(Nd,rel_chk,Fidx,dvadj,deadj,M,poolidx,dualel(:,1),dualel(:,2),bad_edge,sum(pooldeg),maxFsize);
if(newmaxFindex < 0)
    maxFindex = maxFindex + Nd;
else
    maxFindex = newmaxFindex;
end
newfidx=[newfidx;poolidx(2:end)+length(newd)-sum(pooldeg)];

% newfidx=zeros(Nd+1,1);
% cnt=0;
% cntstart=0;
% istart=0;
% %new dual here. we dont have new faces at this point
% for i=1:Nd
%     if rel_chk(i)==0
%
%           if istart==0
%           cntstart=cnt;
%           istart=i;
%           end
%           cnt=cnt+Fidx(i+1)-Fidx(i);
%     else
%         if istart>0
%               newd(cntstart+1:cnt,1)=dvadj(Fidx(istart)+1:Fidx(i)); %can do a larger fill here
%               newe(cntstart+1:cnt,1)=deadj(Fidx(istart)+1:Fidx(i));
%               istart=0;
%         end
%     end
%     newfidx(i+1)=cnt;
% end
%
% if  rel_chk(i)==0
%     i=i+1;
%               newd(cntstart+1:cnt,1)=dvadj(Fidx(istart)+1:Fidx(i)); %can do a larger fill here
%               newe(cntstart+1:cnt,1)=deadj(Fidx(istart)+1:Fidx(i));
% end
%
% f1=rel_chk(newd(1:cnt))>0;
% newd(f1)=Nd+rel_chk(newd(f1));
%
% %then apphend new merged faces at the end
% newe=[newe(1:cnt);poole];  %preallocate these and fill them instead of creating a new one and attaching on the end.
% newd=[newd(1:cnt);poolf];
% newfidx=[newfidx;poolidx(2:end)+cnt];


pooledgemap=pooledgemap(1:poolcnt);
newNd=Nd+poolcnt;
newMd=newfidx(end)/2;

end

