#include "mex.h"
#include "math.h"

void mexFunction( int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[])
{
    double *vadj;
    double *vidx;
    int source;
    int N;
    double *d;
    double *p;
    
    
    vadj = mxGetPr(prhs[0]);
    vidx = mxGetPr(prhs[1]);
    source = mxGetScalar(prhs[2]);
    N = mxGetScalar(prhs[3]);
    
    plhs[0] = mxCreateDoubleMatrix(1,N,mxREAL);
    d = mxGetPr(plhs[0]);
    plhs[1] = mxCreateDoubleMatrix(1,N,mxREAL);
    p = mxGetPr(plhs[1]);
    
    find_sp(vadj,vidx,source,N,d,p);
}

void find_sp(double *vadj, double *vidx, int source, int N, double *d, double *p)
{
    int totaldone = 1;
    bool done[N];
    mwSize jj;
    for(jj=0; jj<N; jj++)
        done[jj] = false;
    
    done[source-1] = true;
    int looknext[N+1];
    for(jj=0; jj<N+1; jj++)
        looknext[jj] = 0;
    looknext[0] = source;
    int looknextcount = 1;
    int index = 0;
    int count = 0;
    int gothere = 0;
    
    while(looknext[index] != 0)
    {
        int v = looknext[index];
        
        mwSize i;
        for(i=(int)vidx[v-1];i<(int)vidx[v];i++)
        {
            int check = (int)(vadj[i]);
            if(done[check-1] == false)
            {
                looknext[looknextcount] = check;
                looknextcount = looknextcount+1;
                d[check-1] = d[v-1] + 1;
                p[check-1] = v;
                done[check-1] = true;
                totaldone = totaldone + 1;
            }
        }
        index = index + 1;
    }
}