#include "mex.h"
#include "math.h"

void mexFunction( int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[])
{
    double *dvadj;
    double *Fidx;
    int source;
    int N;
    double *facelist;
    int nav;
    double *dist;
    double *prev;
    
    dvadj = mxGetPr(prhs[0]);
    Fidx = mxGetPr(prhs[1]);
    source = mxGetScalar(prhs[2]);
    N = mxGetScalar(prhs[3]);
    facelist = mxGetPr(prhs[4]);
    nav = mxGetScalar(prhs[5]);
    
    
    int facelistrows = mxGetM(prhs[4]);
    
    plhs[0] = mxCreateDoubleMatrix(N,1,mxREAL);
    dist = mxGetPr(plhs[0]);
    plhs[1] = mxCreateDoubleMatrix(N,1,mxREAL);
    prev = mxGetPr(plhs[1]);
    
    sp_big(dvadj,Fidx,source,N,facelist,facelistrows,nav,dist,prev);
}

void sp_big(double *dvadj, double *Fidx, int source, int N, double *facelist, int facelistrows, int nav, double *dist, double *prev)
{
    bool dest[N*nav];
    bool lookdest[N];
    mwSize i;
    for(i=0; i<N*nav; i++)
        dest[i] = false;
    
    for(i=0; i<N; i++)
        lookdest[i] = false;
    
    mwSize j;
    for(i=0; i<facelistrows; i++)
    {
        for(j=0; j<nav; j++)
        {
            if(facelist[i + j*facelistrows] > 0)
            {
                lookdest[(int)facelist[i + j*facelistrows]-1] = true;
                dest[(int)facelist[i + j*facelistrows]-1 + j*N] = true;
            }
        }
    }
    
    
    
    bool done[N];
    mwSize jj;
    for(jj=0; jj<N; jj++)
        done[jj] = false;
    
    done[source-1] = true;
    
    for(jj=0; jj<N; jj++)
        dist[jj] = N;
    dist[source-1] = 0;
    
    int looknext[N+1];
    for(jj=0; jj<N+1; jj++)
        looknext[jj] = 0;
    looknext[0] = source;
    int looknextcount = 1;
    int index = 0;
    int count = 0;
    
    int destfaces = 0;
    bool checkfaces[nav];
    for(jj=0; jj<nav; jj++)
        checkfaces[jj] = false;
    
    while(looknext[index] != 0)
    {
        int v = looknext[index];

        for(i=(int)Fidx[v-1];i<(int)Fidx[v];i++)
        {
            int check = (int)(dvadj[i]);
            if(done[check-1] == false)
            {
                looknext[looknextcount] = check;
                looknextcount = looknextcount+1;
                //dist[k-1][check-1] = dist[k-1][v-1] + 1;
                dist[check-1] = dist[v-1] + 1;
                //prev[k-1][check-1] = v;
                prev[check-1] = v;
                done[check-1] = true;
                if(lookdest[check-1] == true)
                {
                    mwSize kk;
                    for(kk=1; kk<=nav; kk++)
                    {
                        if(dest[check-1 + (kk-1)*N] == true)
                        {
                            if(checkfaces[kk-1] == false)
                            {
                                checkfaces[kk-1] = true;
                                destfaces = destfaces+1;
                            }
                        }
                    }
                    if(destfaces == nav)
                    {
                        index = N-1;
                        break;
                    }
                }
            }
        }
        index = index + 1;
    }
}