function g6 = convert_to_graph6(A)
%Converts an adjacency matrix of a graph in graph6 format.  See
%http://users.cecs.anu.edu.au/~bdm/data/formats.txt for details.

N = size(A,1);

if(N <= 62)
    Nn = char(N + 63);
else
    temp = N;
    result = zeros(18,1);
    for i=17:-1:0
        if(temp >= 2^i)
            result(18-i) = 1;
            temp = temp - 2^i;
        end
    end
    Nn = char([126 (63 + 32*result(1) + 16*result(2) + 8*result(3) + 4*result(4) + 2*result(5) + result(6)) (63 + 32*result(7) + 16*result(8) + 8*result(9) + 4*result(10) + 2*result(11) + result(12)) (63 + 32*result(13) + 16*result(14) + 8*result(15) + 4*result(16) + 2*result(17) + result(18))]);
end

% for i=1:length(Nn)
%     if(Nn(i) == '\')
%         Nn(i+2:length(Nn)+1) = Nn(i+1:length(Nn));
%         Nn(i+1) = '\';
%         i = i + 1;
%     end
% end


vector = zeros(ceil(N*(N-1)/12)*6,1);

count = 0;
for j=2:N
    for i=1:j-1
        count = count + 1;
        vector(count,1) = A(i,j);
    end
end

ascii_numbers = zeros(1,ceil(N*(N-1)/12));

slash_count = 0;
for i=1:ceil(N*(N-1)/12)
    v = vector((i-1)*6+1:i*6,1);
    ascii_numbers(1,i+slash_count) = 63 + 32*v(1) + 16*v(2) + 8*v(3) + 4*v(4) + 2*v(5) + v(6);
%     if(ascii_numbers(1,i+slash_count) == 92)
%         slash_count = slash_count + 1;
%         ascii_numbers(1,i+1) = 92;
%     end
end



g6 = [Nn char(ascii_numbers)];