function A = read_graph6(string)
% Converts a graph6 string into an adjacency matrix.  See
% http://users.cecs.anu.edu.au/~bdm/data/formats.txt for details.

numbers = string + 0;
startindex = 0;
if(numbers(1) == 126)
    if(numbers(2) == 126)
        startindex = 9;
        binary = zeros(1,36);
        numbers(3:8) = numbers(3:8)-63;
        for i=3:8
            for j=1:6
                if(numbers(i) >= 2^(6-j))
                    binary((i-2)*6+j) = 1;
                    numbers(i) = numbers(i) - 2^(6-j);
                end
            end
        end
        N = 0;
        for i=36:-1:1
            if(binary(i))
                N = N + 2^(36-i);
            end
        end
    else
        startindex = 5;
        binary = zeros(1,18);
        numbers(2:4) = numbers(2:4)-63;
        for i=2:4
            for j=1:6
                if(numbers(i) >= 2^(6-j))
                    binary((i-2)*6+j) = 1;
                    numbers(i) = numbers(i) - 2^(6-j);
                end
            end
        end
        N = 0;
        for i=18:-1:1
            if(binary(i))
                N = N + 2^(18-i);
            end
        end
    end
    
   
        
else
    startindex = 2;
    N = numbers(1) - 63;
end
A = zeros(N);

column = 2;
row = 1;

for i=startindex:length(numbers)
    number = numbers(i);
    number = number-63;
    binary = zeros(1,6);
    for j=1:6
        if(number >= 2^(6-j))
            binary(j) = 1;
            number = number - 2^(6-j);
        end
    end
    for j=1:6
        A(row,column) = binary(j);
        A(column,row) = binary(j);
        row = row + 1;
        if(row == column)
            row = 1;
            column = column + 1;
            if(column > N)
                return;
            end
        end
    end
end
        